%ext ck3
%version 1.31

########################
# HARD MODE PATCH FILE #
########################

# In this version of the game, Keen begins each level with
# only 10 seconds on the clock, and each stopwatch item
# gives him slightly less than full time.  28 for gold and
# 8 for silver.  Spadlings take one additional shot to
# defeat, and the logs move just a little bit faster.
# Many of the levels are only completable through
# memorization--in this mode, scores are guaranteed to be
# lower.  NOT FOR THE BEGINNING KEENER!!

########################
# HARD MODE PATCH FILE #
########################

# Let's get that TileInfo going!
%patchfile 0x198C8 XkyK3.tli

# LOADING:
%patch 0x0001bba7 "Loading XkyKeen3, staring Commander Keen.... (10/22/05)"

# The title bitmap will be shown at offset 0,0 
%patch $A08C   $00 $00     # Y location, in pixels 
%patch $A090   $04 $00     # (X location in pixels) / 8 + 4 

# STORY MAIN MENU TEXT
%patch 0x00018c0b "    == Episode Dash!! ==     "
%patchfile 0x00018e1b xk3rev.ck3
%patch 0x00018fc1 "~     An Intergalactic GameShow!?"
%patchfile 0x00018fe6 xk3cur.ck3
%patch 0x0001927B "~    The Forbidden Planet's Rules:"
%patchfile 0x0001929d xk3task.ck3
%patch 0x000193Fd " Information on this wild planet: "
%patchfile 0x00019421 xk3info.ck3
%patch 0x0001974a "~        Let the games begin!"
%patch 0x0001976c "Your task is before you.  Have at it, Commander Keen! "
%patch 0x000197cb "This gameshow is "
%patch 0x000197e6 "pretty keen!"

# About ID...
%patch 0x0001C807 "Xky"
%patch 0x0001c870 "Xky Rauh is a long-time Commander "
%patch 0x0001c898 "Keen fan whose goal with this mod"
%patch 0x0001c8c0 "was to uphold the spirit and  "
%patch 0x0001c8e8 "fun of the original."
%patch 0x0001c910 "This effort was only possible   "
%patch 0x0001c938 "with support from people like Andy "
%patch 0x0001c960 "Durdin and the many Keen  "
%patch 0x0001c988 "fans at Keen:Modding.  "
%patch 0x0001c9b0 "Thank you in advance for your"
%patch 0x0001c9d8 "interest in my work, and being so"
%patch 0x0001ca00 "patient for its release! "

# ORDERING INFO
%patch 0x0001c821 "Modding Info "
%patch 0x0001cbf2 "Commander Keen: Episode Dash!  "
%patch 0x0001cc16 "is a stand-alone mod made possible"
%patch 0x0001cc42 "thru community support.  "
%patch 0x0001cc61 "Join the Keen:Modding Community:  "
%patch 0x0001cc87 "* Get Map, Text and Graphic Editors"
%patch 0x0001ccae "* Learn how to Manipulate Game Data"
%patch 0x0001ccd5 "* Work on the Keen Community Mod "
%patch 0x0001ccfa "* Build a Mod of your own! "
%patch 0x0001cd18 " The Keen:Modding forum's address is"
%patch 0x0001cd3e "http://andy.durdin.net/keen/modding/ "
%patch 0x0001cd65 " Also, be sure to check Beyond the Pogo"
%patch 0x0001cd8e "http://www.spatang.com/ck         "
%patch 0x0001cdB3 "There are many awesome mods to download "
%patch 0x0001cde0 "...and more are on the way in 2005!"

# PREVIEWS!                 #
%patch 0x0001c833 "Community"
%patch 0x000184e4 " A LETTER TO THE CK COMMUNITY: "
%patchfile 0x00018505 xk3prev.ck3
%patch 0x00018B5B "  " 0x22 "With or without TUIT," 0x1F 0x0D 0x0A 0x20 0x99 0x9A "   we can--and will--mod our" 0x1F 0x0D 0x0A "      way to a Keener future!" 0x22 0x0D 0x0A 0x0D 0x0A
%patch 0x00018BBA "--XkyRauh"

# STATUS BAR CHANGES
%patch 0x0001bb08 "LIFE"      #KEEN
%patch 0x0001bb19 "LIVES"     #KEENS
%patch 0x0001bb2a "N.STUN"    #PISTOL
%patch 0x0001bb3d "SHOW TIME" #ANKH TIME

# HIGH SCORE CHANGES
%patch 0x0001C5b1 "Narln"
%patch 0x0001c5c0 "Shikadi"
%patch 0x0001c5cf "Dash!!"

# CHEATING MESSAGES
%patch 0x0001ba9e "Cheat mode activated!"
%patch 0x0001bab5 "Got all keyletters  "
%patch 0x0001bacb "and 100 shots for the "
%patch 0x0001bae3 "Neural Stunner. "
%patch 0x0001bb80 "game's easy now "
%patch 0x0001bb91 "game's hard again"

# change the point values of the items you gather
%patch $1C085 $54 $00   # 100 point item = 84 points
%patch $1C087 $B6 $00   # 200 point item = 182 points
%patch $1C083 $9D $01   # 500 point item = 413 points
%patch $1C089 $A3 $03   # 1000 point item = 931 points
%patch $1C08B $D4 $07   # 5000 point item = 2004 points

# 'your ship' messages
%patch 0x0001ce04 "'Go get 'em, Commander Keen!!!'"
%patch 0x0001ce25 " shouts the announcer, and a"
%patch 0x0001ce43 " surge of applause rises from "
%patch 0x0001ce63 " the crowd's ranks! "
%patch 0x0001cE78 "The crowd in the stands looks "
%patch 0x0001ce98 "at you expectantly; some with"
%patch 0x0001ceb7 "smiles, others with glares... "
%patch 0x0001ced6 "'Keen looks like he needs some "
%patch 0x0001cef7 " encouragement, folks!'   "
%patch 0x0001cf13 " says the announcer, and a loud "
%patch 0x0001cf35 " cheer instantly ensues!   "
%patch 0x0001cf51 "The crowd watches you with a"
%patch 0x0001cf6f "buzzing anticipation, eager to "
%patch 0x0001cf90 "see whether or not you'll "
%patch 0x0001cfac "get the planet's treasure! "

# OMG F1 "HALP!" STUFF
%patch 0x00017CCF 0x20
%patch 0x00017DCC "When you are on the world map, you'll notice a series of numbered levels along"
%patch 0x00017E1C "the path to the right.  All of these levels are optional, except the last"
%patch 0x00017e67 "level, number 16. "
%patch 0x00017e7d "When inside a course, you can get goodies"
%patch 0x00017eF9 "keyletter"
%patch 0x00017f1d "Keyletters share colors with the door they open."
%patch 0x00017F51 "Network time is expensive, so you should collect as much treasure and time "
%patch 0x00017F9E "as you can.  Be fast, but be thorough."
%patch 0x00017FE5 "loose"
%patch 0x00017FF7 " 84 points"
%patch 0x00018006 "change   "
%patch 0x0001801A "single"
%patch 0x0001802C "182 points"
%patch 0x0001803b "dollar bill"
%patch 0x0001804f "big pile of"
%patch 0x00018061 "413 points"
%patch 0x00018070 "money "
%patch 0x00018084 "little sack"
%patch 0x00018096 "931 points"
%patch 0x000180A6 "of money  "
%patch 0x000180BA "huge sack  "
%patch 0x000180Cb "2004 points"
%patch 0x000180DC "of money  "
%patch 0x000180ff "film"
%patch 0x00018141 0x22 "Good luck with the time " 0x1F 0x0D 0x0A "      limit...  This is tough!" 0x22 "  "

#Spadlings take three shots to defeat in hard mode
%patch $3D1C $03 $00 

#Trinins take one shot to defeat
%patch $3DE6 $00 $00 

###################################################
### ((( begin Durdin's kickass Ankh hacking ))) ###
###################################################

#SIDE EFFECT: "Message Popup" tiles will have no effect (but who cares)
#SIDE EFFECT: Areas of tiles with a general behaviour other than
#    "Nothing" will be "safe areas" where the time does *not* affect
#    Keen -- you could use "Message Popup" if you desire this behaviour

# Setting Ankh to give 28 seconds of time (28 * 144 = $0FC0)
%patch $7BA3  $C0 $0F

# Set Ankh time to 11 secs (11 * 144 = $0630) when entering level
# (side-effect: won't turn off God mode when entering level)
%patch $81CE  $C7 $06 $46 $99 $30 $06

# Set single bullet to give 8 seconds of ankh time (8 * 144 = $0480)
%patch $7BD2 $81 $06 $46 $99 $80 $04 $EB $CB

# Set Ankh flashing time (when time running out) to when there's 8 
# seconds left (8 * 144 = $0480)
%patch $84FE  $80 $04

# Make Keen die when ankh time runs out (using black magic)
%patch $7A1C  $E9 $4E $01
%patch $7B6D  $83 $3E $46 $99 $00 $7F $03 $E9 $BB $FE $E9 $89 $00
%patch $7C45  $03 $7C

# The ankh does not make Keen invincible
%patch $7918  $EB

# The ankh does not stop vortikids from knocking over Keen
%patch $7C8A  $EB

# The "invincibility sprite" is not shown until the "time running out" 
# time is reached (even for God mode).
# SIDE EFFECT: with God mode on, once the timer is depleted,
# the "time running out" frames will continue to flash.
%patch $8502 $EB $74

#################################################
### ((( end Durdin's kickass Ankh hacking ))) ###
#################################################

# Horizontal platform speed (default $004B, range (-$0100 = $FF00)) 
%patch $3FB9  $1d $00 
%patch $4C6A  $1d $00 
%patch $4C89  $FF $FF 

# Vertical platform speed (default $004B, range (-$0010 = $FFF0)) 
%patch $3FFB  $00 $00 
%patch $4CA6  $00 $00 
%patch $4CC5  $00 $00 

#################################################
# LAST LEVEL CHAT WITH MORTIMER / ANNOUNCER :-) #
#################################################
# Format used:
# %patch 0x000000 "This text has been modified... "
#                 #This is the original game text.

%patch 0x0001c08d "Woah!"  
                  #No...
%patch 0x0001c093 "So amazing!!" 
                  #It can't be!
%patch 0x0001c0a0 "He's almost done!!" 
                  #MORTIMER McMIRE!!!
%patch 0x0001c0b3 "Ladies and gentlemen, let me just say " 
                  #Mortimer has been a thorn in your side
%patch 0x0001c0db "that this young man is really keen!   " 
                  #for as long as you can remember.  Your
%patch 0x0001c103 "He's overcome some crazy obstacles on"    
                  #IQ test score was 314--Mortimer's was
%patch 0x0001c12a "his way through today's show--and  "
                  #315.  He always held that over you,
%patch 0x0001c14f "all on a previously uncleared planet!"
                  #never letting you forget for one day.
%patch 0x0001c176 "Nevermind the legal issues we had  "
                  #All the practical jokes, the mental
%patch 0x0001c19b "to work around to get today's show"
                  #cruelty, the swirlies--each memory
%patch 0x0001c1bf "past the censors--our player deserves "
	          #makes your teeth grit harder.  And now
%patch 0x0001c1e7 "a big round of applause!  Let's hear"
                  #he's out to destroy earth!  You have
%patch 0x0001c20d "it for him!"
                  #had enough!
%patch 0x0001c21a "(as the crowd goes wild, Billy "
                  #"ALL RIGHT MORTIMER, WHAT's THE
%patch 0x0001c23b " takes a moment to breathe..)"
		  #PROBLEM?  WHY DESTROY EARTH?"
%patch 0x0001c25a 0x22 "All I have to do now is find  "
		  #"You and all those mental wimps
%patch 0x0001c27b "the game-end target and shoot it."
		  #deserve to die!  I'm the smartest
%patch 0x0001c29e "The show's host said it would be"
		  #person in the galaxy.  Aren't I,
%patch 0x0001c2c0 "obvious.  I'll just stay alert." 0x22 0x20
		  #mister THREE FOURTEEEN!  Ah ha ha!"
%patch 0x0001c2e2 "(the Announcer speaks up again...)"
		  #"I'll get you for that, Mortimer!"
%patch 0x0001c305 "Well, enough with the yacking--let's "
		  #"Come and try!  You'll never get past
%patch 0x0001c32c "get back to the game!  Our contestant"
		  #my hideous Mangling Machine!  Prepare
%patch 0x0001c353 "has reached the finale!!"
		  #to die, Commander Clown!"

# VICTORY CHAT WITH KING VORTICON
%patch 0x0001c36D "Breathing heavy but smiling the whole "
                  #With Mortimer McMire out of the       "
%patch 0x0001c395 "time, Keen steps into the winner's  "
                  #picture, and his brain-wave belts no"
%patch 0x0001c3bb "circle and approaches the announcer,  "
                  #longer controlling them, the Vorticons"
%patch 0x0001c3e3 "who is busy working the excited crowd."
                  #are freed of their mental enslavement."
%patch 0x0001c40B 0x22 "Commander Keen, you passed Forbidden "
                  #"Commander Keen, in honor of your     "   #
%patch 0x0001c433 " Planet, and broke the old high score!"
                  #meritorious service in freeing us from"
%patch 0x0001c45B " Do you have any words for viewers?" 0x22 0x20
                  #the Grand Intellect's mental chains,""
%patch 0x0001c482 0x22 "Yes I do," 0x22 " said Keen, stepping to the"
                  #"I and the other Vorticons you haven't"
%patch 0x0001c4aa " microphone.  " 0x22 "Mortimer, I've got just"
                  #slaughtered want to award you the     "
%patch 0x0001c4d2 " one thing to say: You..." 0x22
                  #Big V, our highest honor.""
%patch 0x0001c4ee 0x22 "are TOAST!" 0x22
                  #"Thank you!""

# END GAME CONGRATULATIONS SCREEN
%patchfile 0x000181C7 xk3end.ck3
%patch 0x0001826B 0x1F
%patch 0x00018282 0x1F
%patch 0x000182aa 0x1F
%patch 0x000182ce 0x1F
%patch 0x00018464 0x1F
%patch 0x00018469 0x97 0x98
%patch 0x00018486 0x1F
%patch 0x0001848B 0x99 0x9a
%patch 0x000184A5 0x1F
%patch 0x000184DA "!"

%end
